import { Action } from "@ngrx/store";
import { Patch } from "immer";
export interface Patches {
    patches: Patch[];
    inversePatches: Patch[];
}
export declare type Step = {
    patches: Patches;
    actions: Action[];
};
export declare type History = {
    undoable: Step[];
    undone: Step[];
    mergeBroken: boolean;
};
export declare type HistoryKey = string | number;
export declare type Histories = {
    [id in HistoryKey]: History;
};
export declare type UndoRedoState = {
    histories: Histories;
};
export declare const initialUndoRedoState: UndoRedoState;
export declare const DEFAULT_KEY: HistoryKey;
