import { ActionCreator, ActionType, ReducerTypes } from "@ngrx/store";
import { Draft } from "immer";
export declare type ProduceOnReducer<S, C extends ActionCreator[], D = Draft<S>> = (state: D, action: ActionType<C[number]>) => void | D;
export declare const produceOn: <S, Creators extends ActionCreator<string, import("@ngrx/store").Creator<any[], object>>[]>(...args: [...creators: Creators, reducer: ProduceOnReducer<S, Creators, Draft<S>>]) => ReducerTypes<S, Creators>;
